# coding: utf-8

"""
    DotAAS Part 2 | HTTP/REST | Entire API Collection

    All APIs of the Specification of the [Specification of the Asset Administration Shell: Part 2](http://industrialdigitaltwin.org/en/content-hub) in one collection. Please not that this API is not intended to generate productive code but only for overview purposes.   Publisher: Industrial Digital Twin Association (IDTA) 2023\"  # noqa: E501

    OpenAPI spec version: V3.0.1
    Contact: info@idtwin.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from aas_python_http_client.api_client import ApiClient


class SerializationAPIApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def generate_serialization_by_ids(self, **kwargs):  # noqa: E501
        """Returns an appropriate serialization based on the specified format (see SerializationFormat)  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.generate_serialization_by_ids(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[str] aas_ids: The Asset Administration Shells' unique ids (UTF8-BASE64-URL-encoded)
        :param list[str] submodel_ids: The Submodels' unique ids (UTF8-BASE64-URL-encoded)
        :param bool include_concept_descriptions: Include Concept Descriptions?
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.generate_serialization_by_ids_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.generate_serialization_by_ids_with_http_info(**kwargs)  # noqa: E501
            return data

    def generate_serialization_by_ids_with_http_info(self, **kwargs):  # noqa: E501
        """Returns an appropriate serialization based on the specified format (see SerializationFormat)  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.generate_serialization_by_ids_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[str] aas_ids: The Asset Administration Shells' unique ids (UTF8-BASE64-URL-encoded)
        :param list[str] submodel_ids: The Submodels' unique ids (UTF8-BASE64-URL-encoded)
        :param bool include_concept_descriptions: Include Concept Descriptions?
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['aas_ids', 'submodel_ids', 'include_concept_descriptions']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method generate_serialization_by_ids" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'aas_ids' in params:
            query_params.append(('aasIds', params['aas_ids']))  # noqa: E501
            collection_formats['aasIds'] = 'multi'  # noqa: E501
        if 'submodel_ids' in params:
            query_params.append(('submodelIds', params['submodel_ids']))  # noqa: E501
            collection_formats['submodelIds'] = 'multi'  # noqa: E501
        if 'include_concept_descriptions' in params:
            query_params.append(('includeConceptDescriptions', params['include_concept_descriptions']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/asset-administration-shell-package+xml', 'application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = self.api_client.configuration.get_auth_settings_keys()   # noqa: E501

        return self.api_client.call_api(
            '/serialization', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
