# coding: utf-8

"""
    DotAAS Part 2 | HTTP/REST | Entire API Collection

    All APIs of the Specification of the [Specification of the Asset Administration Shell: Part 2](http://industrialdigitaltwin.org/en/content-hub) in one collection. Please not that this API is not intended to generate productive code but only for overview purposes.   Publisher: Industrial Digital Twin Association (IDTA) 2023\"  # noqa: E501

    OpenAPI spec version: V3.0.1
    Contact: info@idtwin.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from aas_python_http_client.models.has_extensions import HasExtensions  # noqa: F401,E501

class Referable(HasExtensions):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'category': 'str',
        'id_short': 'str',
        'display_name': 'list[LangStringNameType]',
        'description': 'list[LangStringTextType]',
        'model_type': 'ModelType'
    }
    if hasattr(HasExtensions, "swagger_types"):
        swagger_types.update(HasExtensions.swagger_types)

    attribute_map = {
        'category': 'category',
        'id_short': 'idShort',
        'display_name': 'displayName',
        'description': 'description',
        'model_type': 'modelType'
    }
    if hasattr(HasExtensions, "attribute_map"):
        attribute_map.update(HasExtensions.attribute_map)

    def __init__(self, category=None, id_short=None, display_name=None, description=None, model_type=None, *args, **kwargs):  # noqa: E501
        """Referable - a model defined in Swagger"""  # noqa: E501
        self._category = None
        self._id_short = None
        self._display_name = None
        self._description = None
        self._model_type = None
        self.discriminator = None
        if category is not None:
            self.category = category
        if id_short is not None:
            self.id_short = id_short
        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        self.model_type = model_type
        HasExtensions.__init__(self, *args, **kwargs)

    @property
    def category(self):
        """Gets the category of this Referable.  # noqa: E501


        :return: The category of this Referable.  # noqa: E501
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this Referable.


        :param category: The category of this Referable.  # noqa: E501
        :type: str
        """

        self._category = category

    @property
    def id_short(self):
        """Gets the id_short of this Referable.  # noqa: E501


        :return: The id_short of this Referable.  # noqa: E501
        :rtype: str
        """
        return self._id_short

    @id_short.setter
    def id_short(self, id_short):
        """Sets the id_short of this Referable.


        :param id_short: The id_short of this Referable.  # noqa: E501
        :type: str
        """

        self._id_short = id_short

    @property
    def display_name(self):
        """Gets the display_name of this Referable.  # noqa: E501


        :return: The display_name of this Referable.  # noqa: E501
        :rtype: list[LangStringNameType]
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this Referable.


        :param display_name: The display_name of this Referable.  # noqa: E501
        :type: list[LangStringNameType]
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this Referable.  # noqa: E501


        :return: The description of this Referable.  # noqa: E501
        :rtype: list[LangStringTextType]
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Referable.


        :param description: The description of this Referable.  # noqa: E501
        :type: list[LangStringTextType]
        """

        self._description = description

    @property
    def model_type(self):
        """Gets the model_type of this Referable.  # noqa: E501


        :return: The model_type of this Referable.  # noqa: E501
        :rtype: ModelType
        """
        return self._model_type

    @model_type.setter
    def model_type(self, model_type):
        """Sets the model_type of this Referable.


        :param model_type: The model_type of this Referable.  # noqa: E501
        :type: ModelType
        """
        if model_type is None:
            raise ValueError("Invalid value for `model_type`, must not be `None`")  # noqa: E501

        self._model_type = model_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Referable, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Referable):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
